% (C) Mario Guimaraes 14 Nov 2001

function sout = gen_sub

global bIsSpatial nsubjects nsbjcategories psubjects natoms nmaxradius nminradius nminsubspercli nmaxsubspercli

i = 1;
    
if bIsSpatial
    r =  nminradius + fix((nmaxradius - nminradius + 1) * rand);
    nsbj = 1 + fix(rand * nsubjects);
    asbj = [max(nsbj-r,1):min(nsbj+r,nsubjects)];
    natom = 1 + fix(rand * natoms);
    nminatom = max(natom-r,1);
    nmaxatom = min(natom+r,natoms);  

    for sbj = asbj
        for natm = nminatom:nmaxatom
            sout{i,1} = sbj;
%            sout{i,2} = [nminatom ; nmaxatom] + (sbj - 1) * natoms;
            sout{i,2} = [natm ; natm] + (sbj - 1) * natoms;
            i = i + 1;
        end
    end
else
    nsbjpercategory = fix(nsubjects / nsbjcategories);
    nmaxsbjpercli = min(fix(nsubjects * psubjects), nsbjpercategory);

    if nsbjcategories > 1
        nsbjcat = fix(rand * nsbjcategories) + 1;
        asbj = selectdiffnum(nsbjpercategory * (nsbjcat - 1) + 1, nsbjpercategory * nsbjcat, nmaxsbjpercli);
    else
        asbj = selectdiffnum(1, nsubjects, nmaxsbjpercli);
    end

    for sbj = asbj
        nsub = nminsubspercli + fix(nmaxsubspercli * rand); % num of subscriptions    
        c = selectdiffnum(1, natoms, nsub); % subscription's centroids
        r =  nminradius + fix((nmaxradius - nminradius + 1) * rand(1, nsub));  % subscription's radius
        sout{i,1} = sbj;
        sout{i,2} = union_sub([c - r; c + r], natoms) + (sbj - 1) * natoms;
        i = i + 1;
    end
end