function [val, agroupsdiff] = eqind(ind1,ind2)

if size(ind1,1) ~= size(ind2,1), val = 0; agroupsdiff = 1; return; end

val = 1;
nsize = size(ind1,1);
agroupsdiff = uint8(zeros(1,nsize));

for i = 1:nsize
    if length(ind1{i}) ~= length(ind2{i})
        agroupsdiff(i) = 1;
        val = 0;
    elseif length(setdiff(ind1{i},ind2{i})) > 0 | length(setdiff(ind2{i},ind1{i})) > 0
        agroupsdiff(i) = 1;
        val = 0;
    end
end