% (C) Mario Guimaraes 1 Nov 2001

function aWeights = gen_atoms()

global nsubjects natoms maxatom_weigth maxsbj_power

asbjAtoms = fix(rand(natoms, nsubjects) * maxatom_weigth) + 1;
asbjAtomsCS = cumsum(asbjAtoms, 1);

aWeights = zeros(natoms, nsubjects);

for i = 1:nsubjects
    asbjWeight = 1 + fix(rand * maxsbj_power);
    aWeights(:,i) = (10^asbjWeight) * asbjAtoms(:,i) ./ asbjAtomsCS(natoms,i);
end